package com.unipi.talepis.iatriki2024_2;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Optional;

@RestController
public class AppController {
    @Autowired
    private BeverageRepository beverageRepository;
    @GetMapping("/beverages")
    public List<Beverage> getAll(){
        return beverageRepository.findAll();
    }
    @PostMapping("/newBeverage")
    public Beverage addBeverage(@RequestBody Beverage beverage){
        return beverageRepository.save(beverage);
    }
    @GetMapping("/find/{id}")
    public Beverage findById(@PathVariable double id){
        Optional<Beverage> beverageOptional = beverageRepository.findById(id);
        if (beverageOptional.isPresent())
            return beverageOptional.get();
        else return new Beverage();
    }
    @PutMapping("updateBeverage")
    public Beverage updateBeverage(@RequestBody Beverage beverage){
        /*double id = beverage.getCode();
        Beverage temp;
        Optional<Beverage> beverageOptional = beverageRepository.findById(id);
        if (beverageOptional.isPresent())
            temp = beverageOptional.get();*/
        return beverageRepository.save(beverage);
    }
    @GetMapping("/findByExactTitle")
    public Beverage findByExactTitle(@RequestParam String title){
        return beverageRepository.findBeverageByTitle(title);
    }
    @GetMapping("/findByTitle")
    public List<Beverage> findByTitle(@RequestParam String keyword){
        return beverageRepository.findBeveragesByTitleContaining(keyword);
    }
}
